Loading...
Searching...
No Matches
pcl::io::ply::ply_parser Class Reference

Class ply_parser parses a PLY file and generates appropriate atomic parsers for the body. More...

`#include <pcl/io/ply/ply_parser.h>`

## Classes

struct | scalar_property_callback_type
struct | scalar_property_definition_callback_type
class | scalar_property_definition_callbacks_type
struct | list_property_begin_callback_type
struct | list_property_element_callback_type
struct | list_property_end_callback_type
struct | list_property_definition_callback_type
class | list_property_definition_callbacks_type

## Public Types

enum | flags
using | info_callback_type = std::function<void (std::size_t, const std::string&)>
using | warning_callback_type = std::function<void (std::size_t, const std::string&)>
using | error_callback_type = std::function<void (std::size_t, const std::string&)>
using | magic_callback_type = std::function<void ()>
using | format_callback_type = std::function<void (format_type, const std::string&)>
using | comment_callback_type = std::function<void (const std::string&)>
using | obj_info_callback_type = std::function<void (const std::string&)>
using | end_header_callback_type = std::function<bool ()>
using | begin_element_callback_type = std::function<void ()>
using | end_element_callback_type = std::function<void ()>
using | element_callbacks_type = std::tuple<begin_element_callback_type, end_element_callback_type>
using | element_definition_callback_type = std::function<element_callbacks_type (const std::string&, std::size_t)>
using | scalar_types = boost::mpl::vector<int8, int16, int32, uint8, uint16, uint32, float32, float64>
using | size_types = boost::mpl::vector<uint8, uint16, uint32>
using | flags_type = int

## Public Member Functions

void | info_callback (const info_callback_type &info_callback)
void | warning_callback (const warning_callback_type &warning_callback)
void | error_callback (const error_callback_type &error_callback)
void | magic_callback (const magic_callback_type &magic_callback)
void | format_callback (const format_callback_type &format_callback)
void | element_definition_callback (const element_definition_callback_type &element_definition_callback)
void | scalar_property_definition_callbacks (const scalar_property_definition_callbacks_type &scalar_property_definition_callbacks)
void | list_property_definition_callbacks (const list_property_definition_callbacks_type &list_property_definition_callbacks)
void | comment_callback (const comment_callback_type &comment_callback)
void | obj_info_callback (const obj_info_callback_type &obj_info_callback)
void | end_header_callback (const end_header_callback_type &end_header_callback)
| ply_parser ()=default
bool | parse (const std::string &filename)

## Static Public Member Functions

template<typename ScalarType>
static scalar_property_definition_callback_type< ScalarType >::type & | at (scalar_property_definition_callbacks_type &scalar_property_definition_callbacks)
template<typename ScalarType>
static const scalar_property_definition_callback_type< ScalarType >::type & | at (const scalar_property_definition_callbacks_type &scalar_property_definition_callbacks)
template<typename SizeType, typename ScalarType>
static list_property_definition_callback_type< SizeType, ScalarType >::type & | at (list_property_definition_callbacks_type &list_property_definition_callbacks)
template<typename SizeType, typename ScalarType>
static const list_property_definition_callback_type< SizeType, ScalarType >::type & | at (const list_property_definition_callbacks_type &list_property_definition_callbacks)

## Detailed Description

Class ply_parser parses a PLY file and generates appropriate atomic parsers for the body.

Author
  Ares Lagae as part of libply, Nizar Sallem Ported with agreement from the author under the terms of the BSD license.

Definition at line 73 of file ply_parser.h.

## Member Typedef Documentation

## begin_element_callback_type

using pcl::io::ply::ply_parser::begin_element_callback_type = std::function<void ()>

Definition at line 87 of file ply_parser.h.

## comment_callback_type

using pcl::io::ply::ply_parser::comment_callback_type = std::function<void (const std::string&)>

Definition at line 83 of file ply_parser.h.

## element_callbacks_type

using pcl::io::ply::ply_parser::element_callbacks_type = std::tuple<begin_element_callback_type, end_element_callback_type>

Definition at line 89 of file ply_parser.h.

## element_definition_callback_type

using pcl::io::ply::ply_parser::element_definition_callback_type = std::function<element_callbacks_type (const std::string&, std::size_t)>

Definition at line 90 of file ply_parser.h.

## end_element_callback_type

using pcl::io::ply::ply_parser::end_element_callback_type = std::function<void ()>

Definition at line 88 of file ply_parser.h.

## end_header_callback_type

using pcl::io::ply::ply_parser::end_header_callback_type = std::function<bool ()>

Definition at line 85 of file ply_parser.h.

## error_callback_type

using pcl::io::ply::ply_parser::error_callback_type = std::function<void (std::size_t, const std::string&)>

Definition at line 79 of file ply_parser.h.

## flags_type

using pcl::io::ply::ply_parser::flags_type = int

Definition at line 294 of file ply_parser.h.

## format_callback_type

using pcl::io::ply::ply_parser::format_callback_type = std::function<void (format_type, const std::string&)>

Definition at line 82 of file ply_parser.h.

## info_callback_type

using pcl::io::ply::ply_parser::info_callback_type = std::function<void (std::size_t, const std::string&)>

Definition at line 77 of file ply_parser.h.

## magic_callback_type

using pcl::io::ply::ply_parser::magic_callback_type = std::function<void ()>

Definition at line 81 of file ply_parser.h.

## obj_info_callback_type

using pcl::io::ply::ply_parser::obj_info_callback_type = std::function<void (const std::string&)>

Definition at line 84 of file ply_parser.h.

## scalar_types

using pcl::io::ply::ply_parser::scalar_types = boost::mpl::vector<int8, int16, int32, uint8, uint16, uint32, float32, float64>

Definition at line 105 of file ply_parser.h.

## size_types

using pcl::io::ply::ply_parser::size_types = boost::mpl::vector<uint8, uint16, uint32>

Definition at line 197 of file ply_parser.h.

## warning_callback_type

using pcl::io::ply::ply_parser::warning_callback_type = std::function<void (std::size_t, const std::string&)>

Definition at line 78 of file ply_parser.h.

## Member Enumeration Documentation

## flags

enum pcl::io::ply::ply_parser::flags

Definition at line 295 of file ply_parser.h.

## Constructor & Destructor Documentation

## ply_parser()

pcl::io::ply::ply_parser::ply_parser | ( |  | ) |

default

## Member Function Documentation

## at() [1/4]

template<typename SizeType, typename ScalarType>

const list_property_definition_callback_type< SizeType, ScalarType >::type & pcl::io::ply::ply_parser::at | ( | const list_property_definition_callbacks_type & | list_property_definition_callbacks | ) |

inline static

Definition at line 255 of file ply_parser.h.

References list_property_definition_callbacks().

## at() [2/4]

template<typename ScalarType>

const scalar_property_definition_callback_type< ScalarType >::type & pcl::io::ply::ply_parser::at | ( | const scalar_property_definition_callbacks_type & | scalar_property_definition_callbacks | ) |

inline static

Definition at line 161 of file ply_parser.h.

References scalar_property_definition_callbacks().

## at() [3/4]

template<typename SizeType, typename ScalarType>

list_property_definition_callback_type< SizeType, ScalarType >::type & pcl::io::ply::ply_parser::at | ( | list_property_definition_callbacks_type & | list_property_definition_callbacks | ) |

inline static

Definition at line 248 of file ply_parser.h.

References list_property_definition_callbacks().

## at() [4/4]

template<typename ScalarType>

scalar_property_definition_callback_type< ScalarType >::type & pcl::io::ply::ply_parser::at | ( | scalar_property_definition_callbacks_type & | scalar_property_definition_callbacks | ) |

inline static

Definition at line 153 of file ply_parser.h.

References scalar_property_definition_callbacks().

## comment_callback()

void pcl::io::ply::ply_parser::comment_callback | ( | const comment_callback_type & | comment_callback | ) |

inline

Definition at line 469 of file ply_parser.h.

References comment_callback().

Referenced by comment_callback().

## element_definition_callback()

void pcl::io::ply::ply_parser::element_definition_callback | ( | const element_definition_callback_type & | element_definition_callback | ) |

inline

Definition at line 454 of file ply_parser.h.

References element_definition_callback().

Referenced by element_definition_callback().

## end_header_callback()

void pcl::io::ply::ply_parser::end_header_callback | ( | const end_header_callback_type & | end_header_callback | ) |

inline

Definition at line 479 of file ply_parser.h.

References end_header_callback().

Referenced by end_header_callback().

## error_callback()

void pcl::io::ply::ply_parser::error_callback | ( | const error_callback_type & | error_callback | ) |

inline

Definition at line 439 of file ply_parser.h.

References error_callback().

Referenced by error_callback().

## format_callback()

void pcl::io::ply::ply_parser::format_callback | ( | const format_callback_type & | format_callback | ) |

inline

Definition at line 449 of file ply_parser.h.

References format_callback().

Referenced by format_callback().

## info_callback()

void pcl::io::ply::ply_parser::info_callback | ( | const info_callback_type & | info_callback | ) |

inline

Definition at line 429 of file ply_parser.h.

References info_callback().

Referenced by info_callback().

## list_property_definition_callbacks()

void pcl::io::ply::ply_parser::list_property_definition_callbacks | ( | const list_property_definition_callbacks_type & | list_property_definition_callbacks | ) |

inline

Definition at line 464 of file ply_parser.h.

References list_property_definition_callbacks().

Referenced by at(), at(), pcl::io::ply::ply_parser::list_property_definition_callbacks_type::at, pcl::io::ply::ply_parser::list_property_definition_callbacks_type::at, and list_property_definition_callbacks().

## magic_callback()

void pcl::io::ply::ply_parser::magic_callback | ( | const magic_callback_type & | magic_callback | ) |

inline

Definition at line 444 of file ply_parser.h.

References magic_callback().

Referenced by magic_callback().

## obj_info_callback()

void pcl::io::ply::ply_parser::obj_info_callback | ( | const obj_info_callback_type & | obj_info_callback | ) |

inline

Definition at line 474 of file ply_parser.h.

References obj_info_callback().

Referenced by obj_info_callback().

## parse()

bool pcl::io::ply::ply_parser::parse | ( | const std::string & | filename | ) |

## scalar_property_definition_callbacks()

void pcl::io::ply::ply_parser::scalar_property_definition_callbacks | ( | const scalar_property_definition_callbacks_type & | scalar_property_definition_callbacks | ) |

inline

Definition at line 459 of file ply_parser.h.

References scalar_property_definition_callbacks().

Referenced by at(), at(), pcl::io::ply::ply_parser::scalar_property_definition_callbacks_type::at, pcl::io::ply::ply_parser::scalar_property_definition_callbacks_type::at, and scalar_property_definition_callbacks().

## warning_callback()

void pcl::io::ply::ply_parser::warning_callback | ( | const warning_callback_type & | warning_callback | ) |

inline

Definition at line 434 of file ply_parser.h.

References warning_callback().

Referenced by warning_callback().

The documentation for this class was generated from the following file:

- pcl/io/ply/ply_parser.h